[![CodeFactor](https://www.codefactor.io/repository/github/kmilo17pet/quarkts-cpp/badge)](https://www.codefactor.io/repository/github/kmilo17pet/quarkts-cpp)
[![Codacy Badge](https://app.codacy.com/project/badge/Grade/b3d75b3d6e2c4733ab87fd8bab6f4dea)](https://app.codacy.com/gh/kmilo17pet/QuarkTS-cpp/dashboard?utm_source=gh&utm_medium=referral&utm_content=&utm_campaign=Badge_grade)
[![DeepSource](https://deepsource.io/gh/kmilo17pet/QuarkTS-cpp.svg/?label=active+issues&show_trend=true&token=MlFRbA4h9mtWn6ZQC_UD8aYZ)](https://deepsource.io/gh/kmilo17pet/QuarkTS-cpp/?ref=repository-badge)

# QuarkTS++

QuarkTS++is the [QuarkTS](https://github.com/kmilo17pet/QuarkTS) port for C++.

* Download the latest release [here](https://github.com/kmilo17pet/QuarkTS-cpp/releases)
* Read the documentation online [here](https://kmilo17pet.github.io/QuarkTS-cpp/)

QuarkTS++ is an operating system that provides a modern environment to build stable and predictable event-driven multitasking embedded software. The OS is built on top of a cooperative quasi-static scheduler and its simplified kernel implements a specialized round-robin scheme using a linked-chain approach and an event-queue to provide true FIFO priority-scheduling.

## Features:

-   Prioritized cooperative scheduling.
-   Time control (Timed tasks and software timers)
-   Inter-Task communication primitives, queues, notifications and event-flags.
-   State-Machines ( hierarchical support )
-   Stackless Co-routines.
-   AT Command Line Interface (CLI)

QuarkTS++ is developed using a formal and rigorous process framed in compliance with the MISRA C++ 2008 and CERT coding standard guidelines and complemented with multiple static-analysis checks targeted to safe critical applications.

QuarkTS++ builds with many different compilers, some of which are more advanced than others. For that reason, QuarkTS++ does not use any of the features or syntax that have been introduced to the C++ language by, or since, the C++11 standard.

